/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

var Advertise = function(){

    var _this = this;
    _this.link_click = false;
    _this.flag = false;
    _this.link = null;
    _this.image = null;
    _this.wnd = null;

    $('#advertise').hide();

    _this.onShow = function(){
        _this.flag = false;
        if(_this.image != null)
        {
            $('#advertise_image').attr('src', _this.image);
            $('#advertise').show();
        }

        if(_this.link != null)
        {
            // $('#advertise_image').click(function(){
            //     _this.link_click = true;
            //     _this.wnd = window.open(_this.link, '_self', 'location=no,zoom=no,hardwareback=no');
            //     _this.wnd.addEventListener('exit', function(){ app.onSecondStep();});
            // });
        }

        setTimeout(function () {
            $('#advertise').hide();
            if(!_this.link_click)
                app.onSecondStep();
        }, 5000);
    }
};

var Notice = function(){
    var _this = this;
    _this.handle = null;
    _this.type = 0;
    _this.flag = false;
    _this.image = null;
    _this.link = null;

    $('#notice_modal1').hide();
    $('#notice_modal2').hide();
    $('#notice_modal3').hide();

    _this.onShow = function () {
        if(_this.image == null)
            return;
        _this.flag = false;
        $('.modal-content').css('background-image', 'url(' + _this.image +  ')');
        $('.modal-content').css('background-size', '100%');
        if(_this.type == 1)
        {
            $('#notice_modal1').show();
        }else if(_this.type == 2)
        {
            $('#notice_modal2').show();
        } else if(_this.type == 3)
        {
            $('#notice_modal3').show();
        }

        // When the user clicks on <span> (x), close the modal
        $('.modal1_close').click(function() {
            $('#notice_modal1').hide();
            app.onShowMainView();
        });

        $('.modal2_close').click(function() {
            $('#notice_modal2').hide();
            app.onShowMainView();
        });

        // When the user clicks anywhere outside of the modal, close it
        window.onclick = function(event) {
            if (event.target == $('#notice_modal3')[0]) {
                $('#notice_modal3').hide();
                app.onShowMainView();
            }
        };
    }
};


var app = {

    // Application Constructor
    initialize: function(url, domain) {
        _this = this;
        _this.wndAd = new Advertise();
        _this.domain = domain;
        _this.wndNotice = new Notice();
        _this.inAppBrowser = null;
        _this.site_id = $( "title" ).prop('innerHTML');
        _this.site_url = url;
        _this.bindEvents();

    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', _this.onDeviceReady, false);
        //this.onDeviceReady();
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function() {

        //Init div windows
        $('#splash').hide();
        $('.swiper-container').hide();
        //document.addEventListener("backbutton", _this.onBackKeyDown, false);
        //$(document).bind('backbutton', _this.onBackKeyDown);

        // _this.wndAd.image = 'http://pic.kuaizhan.com/g2/M01/2B/8D/wKjmqlidmM-AXCBwAAvkVSUNHrY515.png';
        // _this.wndAd.link =  'http://www.baidu.com';
        // _this.wndAd.flag = true;
        //
        // _this.wndNotice.image = 'http://pic.kuaizhan.com/g2/M01/2B/8D/wKjmqlidmM-AXCBwAAvkVSUNHrY515.png';
        // _this.wndNotice.link =  'http://www.baidu.com';
        // _this.wndNotice.type = 1;
        // _this.wndNotice.flag = true;

        var value = window.localStorage.getItem("tutorial");
        if(false)
        {
            $(".swiper-container").show();
            var prevIndex = 0;
            var slideCount = 0;
            slideCount = $(".swiper-container").find(".swiper-slide").length;
            var mySwiper = new Swiper('.swiper-container',{
                pagination: '.pagination',
                paginationClickable: true,
                onSlideChangeEnd: function(s) {
                    prevIndex = s.activeIndex;
                },
                onTouchEnd: function(s) {
                    if(s.activeIndex == slideCount - 1 && prevIndex == s.activeIndex) {
                        window.localStorage.setItem("tutorial", "true");
                        $(".swiper-container").hide();
                        _this.onFirstStep();
                    }
                }
            });
        }
        else
        {
            _this.onFirstStep();
        }

        // $(window).unload(function(){
        //     window.localStorage.removeItem("tutorial");
        // });
    },

    onSecondStep:function(){
        $.ajax({
            url: _this.domain + '?r=api/apps/getCustomConfig&type=notice&site_id=' + _this.site_id,
            type: "get",
            dataType: "json",
            success: function (c) {
                if (c.notice_type > 0) {
                    var notice = c;
                    var curtime = new Date().getTime();
                    if(curtime > notice.start_time && curtime < notice.end_time)
                    {
                        app.wndNotice.image = notice.notice_url;
                        app.wndNotice.link = notice.notice_link;
                        app.wndNotice.type = notice.notice_type;
                        app.wndNotice.flag = true;
                    }
                }
            },
            complete: function (a, c) {
                if(_this.wndNotice.flag == 1)
                    _this.wndNotice.onShow();
                else
                    _this.onShowMainView();

            },
            error: function (e){
                console.log(e);
            },
        });

    },

    onFirstStep:function(){
        $.ajax({
            url: this.domain + '?r=api/apps/getCustomConfig&type=ad&site_id=' + _this.site_id,
            type: "get",
            dataType: "json",
            success: function (c) {
                if (c.ad_type > 0) {
                    var ad = c;
                    var curtime = new Date().getTime();
                    if(curtime > ad.start_time && curtime < ad.end_time)
                    {
                        app.wndAd.image = ad.ad_url;
                        app.wndAd.link = ad.ad_link;
                        app.wndAd.type = ad.ad_type;
                        app.wndAd.flag = true;
                    }
                }
            },
            complete: function (a, c) {
                if(_this.wndAd.flag == 1)
                    _this.wndAd.onShow();
                else
                    _this.onSecondStep();
            },
            error: function (e){
            },
        });

    },


    onBackKeyDown: function(e) {
        if(_this.wndAd.link_click == true)
        {
            _this.wndNotice.link_click = false;
            _this.onSecondStep();

        }else
            navigator.app.backHistory();
        _this.showAlert('back');
    },



    onShowMainView: function(){

        //window.open('main.html');

        _this.inAppBrowser = window.open(_this.site_url, '_blank', 'location=no,zoom=no,hardwareback=yes');
        _this.inAppBrowser.addEventListener("exit", loadExitCallBack);

        function loadExitCallBack(e) {
            navigator.app.exitApp();
            //  navigator.notification.confirm(
            //     '离开 这个应用 ?', // message
            //     onConfirm,            // callback to invoke with index of button pressed
            //     '提示',           // title
            //     ['确认','取消']     // buttonLabels
            // );
        }

        function onConfirm(buttonIndex) {
            if(buttonIndex == 1)
            {
                navigator.app.exitApp();
            }
            else
            {
                param.preventDefault();
                _this.inAppBrowser.location.reload();
            }

        }
    },

    alertDismissed: function() {

    },

    // Show a custom alert
    //
    showAlert: function(msg) {
        navigator.notification.alert(
            msg,
            _this.alertDismissed,
            'Message',
            'Ok'
        );
    },



};

